from nullptr.missions.base import MissionParam
from nullptr.missions.extraction import ExtractionMission
from nullptr.models.waypoint import Waypoint

class SiphonMission(ExtractionMission):
  def start_state(self):
    return 'travel-to'
    
  @classmethod
  def params(cls):
    return {
      'site': MissionParam(Waypoint, True),
    }
  
  def step_siphon(self):
    result = self.api.siphon(self.ship)
    self.next_step = self.ship.cooldown
    if self.ship.cargo_space() > 5:
      return 'more'
    else:
      return 'full'
  
    
  def steps(self):
    return {
      **self.travel_steps('to', 'site', 'siphon'),
        'siphon': (self.step_siphon, {
            'more': 'siphon',
            'full': 'unload'
        }),
        'unload': (self.step_unload, {
            'more': 'unload',
            'done': 'done'
        })
    }
  
    
  
